Index: palm/trunk/SOURCE/data_output_tseries.f90
===================================================================
--- palm/trunk/SOURCE/data_output_tseries.f90	(revision 4901)
+++ palm/trunk/SOURCE/data_output_tseries.f90	(revision 1)
@@ -1,34 +1,52 @@
-!> @file data_output_tseries.f90
-!--------------------------------------------------------------------------------------------------!
-! This file is part of the PALM model system.
-!
-! PALM is free software: you can redistribute it and/or modify it under the terms of the GNU General
-! Public License as published by the Free Software Foundation, either version 3 of the License, or
-! (at your option) any later version.
-!
-! PALM is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the
-! implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
-! Public License for more details.
-!
-! You should have received a copy of the GNU General Public License along with PALM. If not, see
-! <http://www.gnu.org/licenses/>.
-!
-! Copyright 1997-2021 Leibniz Universitaet Hannover
-!--------------------------------------------------------------------------------------------------!
-!
-! Current revisions:
+ SUBROUTINE data_output_tseries
+
+!------------------------------------------------------------------------------!
+! Actual revisions:
 ! -----------------
 ! 
-! 
+!
 ! Former revisions:
 ! -----------------
-! $Id$
-! file re-formatted to follow the PALM coding standard
-!
-! 4360 2020-01-07 11:25:50Z suehring
-! Corrected "Former revisions" section
-!
-! 3655 2019-01-07 16:51:22Z knoop
-! unused format removed
+! $Log: data_output_tseries.f90,v $
+! Revision 1.13  2006/03/14 12:42:51  raasch
+! Error removed: NetCDF output only if switched on
+!
+! Revision 1.12  2006/02/23 10:30:54  raasch
+! Former routine plot_ts renamed data_output_tseries
+! error number argument for handle_netcdf_error
+! plts_anz renamed dots_n
+!
+! Revision 1.11  2005/05/18 15:50:54  raasch
+! Extensions for NetCDF output
+!
+! Revision 1.10  2003/04/16 13:10:40  raasch
+! Output of Monin Obukhov length included
+!
+! Revision 1.9  2001/03/30 07:45:34  raasch
+! Translation of remaining German identifiers (variables, subroutines, etc.)
+!
+! Revision 1.8  2001/01/22 20:36:59  letzel
+! All comments translated into English.
+!
+! Revision 1.7  2001/01/22 07:42:50  raasch
+! Module test_variables removed
+!
+! Revision 1.6  1999/02/05 09:14:35  raasch
+! Erweiterung fuer Ausgabe von Upstream-Anteilen, Erweiterung von ts_value
+! auf 30 Elemente
+!
+! Revision 1.5  1998/07/06 12:26:59  raasch
+! + USE test_variables
+!
+! Revision 1.4  1998/04/15 11:22:22  raasch
+! Erweiterung der Zeitreihenausgabe auf oberflaechennahe Temperaturen und
+! Waermestroeme
+!
+! Revision 1.3  1998/03/30 11:48:03  raasch
+! Divergenzen stehen jetzt in hom
+!
+! Revision 1.2  1998/03/25 13:56:01  raasch
+! Erweiterungen fuer Gebietsstatistiken,
+! dt in dt_3d umbenannt
 !
 ! Revision 1.1  1998/03/03 08:00:13  raasch
@@ -38,36 +56,22 @@
 ! Description:
 ! ------------
-!> Time series output for PROFIL. Always all time series are stored. A selection can be applied via
-!> the PROFIL-parameters in close_file.
-!--------------------------------------------------------------------------------------------------!
- SUBROUTINE data_output_tseries
-
-
-    USE control_parameters,                                                                        &
-        ONLY:  dots_time_count, time_since_reference_point
-
-    USE cpulog,                                                                                    &
-        ONLY:  cpu_log, log_point
-
-    USE kinds
-
-#if defined( __netcdf )
-    USE NETCDF
-#endif
-    USE netcdf_interface,                                                                          &
-        ONLY:  dots_num, id_set_ts, id_var_dots, id_var_time_ts, nc_stat, netcdf_handle_error
-
+! Time series output for PROFIL. Always all time series are stored. A selection
+! can be applied via the PROFIL-parameters in close_file.
+!------------------------------------------------------------------------------!
+
+    USE control_parameters
+    USE cpulog
+    USE indices
+    USE interfaces
+    USE netcdf_control
     USE pegrid
-
     USE profil_parameter
-
-    USE statistics,                                                                                &
-        ONLY:  flow_statistics_called, statistic_regions, ts_value
+    USE statistics
 
     IMPLICIT NONE
 
 
-    INTEGER(iwp) ::  i  !<
-    INTEGER(iwp) ::  sr !<
+    INTEGER ::  file_id, i, j, sr
+    REAL    ::  ts_value(30)
 
 
@@ -84,20 +88,17 @@
 !
 !--    Open file for time series output in NetCDF format
-       CALL check_open( 105 )
-
-!--    Increment the counter for number of output times
-!--    CAUTION: The following line has to be after the call of the subroutine check_open, since
-!--             check_open resets the counter dots_time_count to 0, if a new file is opened
-       dots_time_count = dots_time_count + 1
-
+       IF ( netcdf_output )  THEN
+          dots_time_count = dots_time_count + 1
+          CALL check_open( 105 )
 #if defined( __netcdf )
 !
-!--    Update the time series time axis
-       nc_stat = NF90_PUT_VAR( id_set_ts, id_var_time_ts,                                          &
-                               (/ time_since_reference_point /),                                   &
-                               start = (/ dots_time_count /),                                      &
-                               count = (/ 1 /) )
-       CALL netcdf_handle_error( 'data_output_tseries', 350 )
+!--       Update the time series time axis
+          nc_stat = NF90_PUT_VAR( id_set_ts, id_var_time_ts,     &
+                                  (/ simulated_time /),          &
+                                  start = (/ dots_time_count /), &
+                                  count = (/ 1 /) )
+          IF (nc_stat /= NF90_NOERR)  CALL handle_netcdf_error( 350 )
 #endif
+       ENDIF
 
 !
@@ -105,21 +106,104 @@
 !--    applicable)
        DO  sr = 0, statistic_regions
+!
+!--       Open file for time series output.
+          IF ( profil_output )  THEN
+             file_id = 50 + sr
+             CALL check_open( file_id )
+          ENDIF
+
+!
+!--       Collect and printout all time series quantities in a single line.
+          ts_value(1) = hom(nzb+4,1,var_hom,sr)     ! E
+          ts_value(2) = hom(nzb+5,1,var_hom,sr)     ! E*
+          ts_value(3) = dt_3d
+          ts_value(4) = hom(nzb,1,var_hom,sr)       ! u*
+          ts_value(5) = hom(nzb+3,1,var_hom,sr)     ! th*
+          ts_value(6) = u_max
+          ts_value(7) = v_max
+          ts_value(8) = w_max
+          ts_value(9) = hom(nzb+10,1,var_sum,sr)    ! new divergence
+          ts_value(10) = hom(nzb+9,1,var_hom,sr)    ! old Divergence
+          ts_value(11) = hom(nzb+6,1,var_hom,sr)    ! z_i(1)
+          ts_value(12) = hom(nzb+7,1,var_hom,sr)    ! z_i(2)
+          ts_value(13) = hom(nzb+8,1,var_hom,sr)    ! w*
+          ts_value(14) = hom(nzb,1,16,sr)           ! w'pt'   at k=0
+          ts_value(15) = hom(nzb+1,1,16,sr)         ! w'pt'   at k=1
+          ts_value(16) = hom(nzb+1,1,18,sr)         ! wpt     at k=1
+          ts_value(17) = hom(nzb,1,4,sr)            ! pt(0)
+          ts_value(18) = hom(nzb+1,1,4,sr)          ! pt(zp)
+          ts_value(19) = hom(nzb+9,1,var_hom-1,sr)  ! splptx
+          ts_value(20) = hom(nzb+10,1,var_hom-1,sr) ! splpty
+          ts_value(21) = hom(nzb+11,1,var_hom-1,sr) ! splptz
+          IF ( ts_value(5) /= 0.0 )  THEN
+             ts_value(22) = ts_value(4)**2 / &
+                            ( kappa * g * ts_value(5) / ts_value(18) )  ! L
+          ELSE
+             ts_value(22) = 10000.0
+          ENDIF
 
 #if defined( __netcdf )
-          DO  i = 1, dots_num
-             nc_stat = NF90_PUT_VAR( id_set_ts, id_var_dots(i,sr),                                 &
-                                     (/ ts_value(i,sr) /),                                         &
-                                     start = (/ dots_time_count /),                                &
-                                     count = (/ 1 /) )
-             CALL netcdf_handle_error( 'data_output_tseries', 351 )
-          ENDDO
+          IF ( netcdf_output )  THEN
+             DO  i = 1, dots_num
+                nc_stat = NF90_PUT_VAR( id_set_ts, id_var_dots(i,sr),  &
+                                        (/ ts_value(i) /),             &
+                                        start = (/ dots_time_count /), &
+                                        count = (/ 1 /) )
+                IF ( nc_stat /= NF90_NOERR )  CALL handle_netcdf_error( 351 )
+             ENDDO
+          ENDIF
 #endif
 
-       ENDDO
+          IF ( profil_output )  THEN
+             WRITE ( file_id, 500 )  simulated_time, ts_value(1:22)
+!
+!--          y-value range of the crosses to be drawn by PROFIL
+!--          If required, enlarge them, provided they have not yet been
+!--          specified in
+!--          check_parameters
+             DO  i = 1, dots_n
+
+                j = dots_crossindex(i)
+
+                IF ( cross_ts_uymin(j) == 999.999 )  THEN
+!
+!--                When the value range of the first line in the corresponding
+!--                cross is determined, its value range is simply adopted.
+                   IF ( cross_ts_uymin_computed(j) == 999.999 ) &
+                   THEN
+                      cross_ts_uymin_computed(j) = ts_value(dots_index(i))
+                   ELSE
+                      cross_ts_uymin_computed(j) = &
+                         MIN(cross_ts_uymin_computed(j),ts_value(dots_index(i)))
+                   ENDIF
+                ENDIF
+
+                IF ( cross_ts_uymax(j) == 999.999 )  THEN
+!
+!--                When the value range of the first line in the corresponding
+!--                cross is determined, its value range is simply adopted.
+                   IF ( cross_ts_uymax_computed(j) == 999.999 ) &
+                   THEN
+                      cross_ts_uymax_computed(j) = ts_value(dots_index(i))
+                   ELSE
+                      cross_ts_uymax_computed(j) = &
+                         MAX(cross_ts_uymax_computed(j),ts_value(dots_index(i)))
+                   ENDIF
+                ENDIF
+
+             ENDDO
+
+          ENDIF
+
+       ENDDO   ! Loop of subregions.
 
     ENDIF
 
 
-    CALL cpu_log( log_point(21), 'data_output_tseries', 'stop' )
+    CALL cpu_log( log_point(21), 'data_output_tseries','stop', 'nobarrier' )
+
+!
+!-- formats
+500 FORMAT (23(E15.7,1X))
 
  END SUBROUTINE data_output_tseries
Index: palm/trunk/SOURCE/diffusion_e.f90
===================================================================
--- palm/trunk/SOURCE/diffusion_e.f90	(revision 1)
+++ palm/trunk/SOURCE/diffusion_e.f90	(revision 1)
@@ -0,0 +1,311 @@
+ MODULE diffusion_e_mod
+
+!------------------------------------------------------------------------------!
+! Actual revisions:
+! -----------------
+! 
+!
+! Former revisions:
+! -----------------
+! $Log: diffusion_e.f90,v $
+! Revision 1.18  2006/08/04 14:29:43  raasch
+! dissipation is stored in extra array diss if needed later on for calculating
+! the sgs particle velocities
+!
+! Revision 1.17  2006/02/23 10:31:46  raasch
+! nzb_2d replaced by nzb_s_inner
+!
+! Revision 1.16  2004/01/30 10:18:18  raasch
+! Scalar lower k index nzb replaced by 2d-array nzb_2d
+!
+! Revision 1.15  2003/03/14 13:39:33  raasch
+! Loop optimization for diffusion_e, l and ll are now automatic arrays
+!
+! Revision 1.14  2003/03/12 16:25:03  raasch
+! Full code replaced in the call for all gridpoints instead of calling the
+! _ij version (required by NEC, because otherwise no vectorization)
+!
+! Revision 1.13  2002/12/19 14:25:28  raasch
+! Correction of mixing length term (l(k)/ll(k)). The condition kh=3*km in
+! the unstable case is now also exactly met in the wall adjustment region.
+! Factor 0.7 in wall adjustment part replaced by variable
+! wall_adjustment_factor, which is set to ... in modules.f90.
+!
+! Revision 1.12  2002/06/11 12:51:59  raasch
+! Former subroutine changed to a module which allows to be called for all grid
+! points of a single vertical column with index i,j or for all grid points by
+! using function overloading.
+! 1D-array l is allocated only once in the first call.
+!
+! Revision 1.11  2001/08/21 08:24:34  raasch
+! Wall adjustment of mixing length to 0.7 z can be switched off
+!
+! Revision 1.10  2001/03/30 07:06:30  raasch
+! Near surface mixing length is limited to 0.7*zu,
+! e**1.5 replaced by e*SQRT(e) (more than 10% total increase in performance
+! of this routine),
+! Translation of remaining German identifiers (variables, subroutines, etc.)
+!
+! Revision 1.9  2001/01/22 06:05:28  raasch
+! Module test_variables removed
+!
+! Revision 1.8  2001/01/02 17:27:00  raasch
+! -dpt_dz_d, dpt_dz_u
+!
+! Revision 1.7  2000/07/03 12:56:34  raasch
+! array l changed from dummy argument to local allocatable array,
+! dummy arguments, whose corresponding actual arguments are pointers,
+! are now also defined as pointers
+! all comments translated into English
+!
+! Revision 1.6  2000/04/18 08:10:12  schroeter
+! Revision 1.4 wieder rueckgaengig gemacht, das Stabilitaets-
+! kriterium basiert nun wieder auf zentralen Differenzen
+!
+! Revision 1.5  2000/04/13 14:33:08  schroeter
+! je nach Initialisierungsmodus (trocken/feucht) fliesst in die
+! Berechnung des Mischungsweges pt oder vpt ein, wird durch
+! entsprechende Variablenuebergabe geregelt
+!
+! Revision 1.4  99/02/17  09:15:52  09:15:52  raasch (Siegfried Raasch)
+! Dissipation jetzt gemaess dem originalen Deardorff-Ansatz
+! Kriterium fuer reduzierten Mischungsweg im stabil geschichteten Fall enger
+! gefasst (Schichtung muss sowohl oberhalb als auch unterhalb des betrachteten
+! Gitterpunkts stabil sein)
+! 
+! Revision 1.3  1998/07/06 12:10:56  raasch
+! + USE test_variables
+!
+! Revision 1.2  1998/03/11 11:48:59  raasch
+! Anpassung des Mischungsweges an den Prandtlschen Mischungsweg moeglich
+!
+! Revision 1.1  1997/09/19 07:40:24  raasch
+! Initial revision
+!
+!
+! Description:
+! ------------
+! Diffusion- and dissipation terms for the TKE
+!------------------------------------------------------------------------------!
+
+    PRIVATE
+    PUBLIC diffusion_e
+    
+
+    INTERFACE diffusion_e
+       MODULE PROCEDURE diffusion_e
+       MODULE PROCEDURE diffusion_e_ij
+    END INTERFACE diffusion_e
+ 
+ CONTAINS
+
+
+!------------------------------------------------------------------------------!
+! Call for all grid points
+!------------------------------------------------------------------------------!
+    SUBROUTINE diffusion_e( ddzu, dd2zu, ddzw, diss, e, km, l_grid, theta, &
+                            rif, tend, zu )
+
+       USE control_parameters
+       USE grid_variables
+       USE indices
+       USE particle_attributes
+
+       IMPLICIT NONE
+
+       INTEGER ::  i, j, k
+       REAL            ::  dpt_dz, l_stable, phi_m
+       REAL            ::  ddzu(1:nzt+1), dd2zu(1:nzt), ddzw(1:nzt), &
+                           l_grid(1:nzt), zu(0:nzt+1)
+       REAL, DIMENSION(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1) :: diss, tend
+       REAL, DIMENSION(:,:), POINTER   ::  rif
+       REAL, DIMENSION(:,:,:), POINTER ::  e, km, theta
+       REAL, DIMENSION(nzb+1:nzt-1,nys:nyn) ::  dissipation, l, ll
+ 
+
+       DO  i = nxl, nxr
+          DO  j = nys, nyn
+!
+!--          First, calculate phi-function for eventually adjusting the &
+!--          mixing length to the prandtl mixing length
+             IF ( adjust_mixing_length  .AND.  prandtl_layer )  THEN
+                IF ( rif(j,i) >= 0.0 )  THEN
+                   phi_m = 1.0 + 5.0 * rif(j,i)
+                ELSE
+                   phi_m = 1.0 / SQRT( SQRT( 1.0 - 16.0 * rif(j,i) ) )
+                ENDIF
+             ENDIF
+
+             DO  k = nzb_s_inner(j,i)+1, nzt-1
+!
+!--             Calculate the mixing length (for dissipation)
+                dpt_dz = ( theta(k+1,j,i) - theta(k-1,j,i) ) * dd2zu(k)
+                IF ( dpt_dz > 0.0 ) THEN
+                   l_stable = 0.76 * SQRT( e(k,j,i) ) / &
+                                     SQRT( g / theta(k,j,i) * dpt_dz ) + 1E-5
+                ELSE
+                   l_stable = l_grid(k)
+                ENDIF
+!
+!--             Adjustment of the mixing length
+                IF ( wall_adjustment )  THEN
+                   l(k,j)  = MIN( wall_adjustment_factor * zu(k), l_grid(k), &
+                                  l_stable )
+                   ll(k,j) = MIN( wall_adjustment_factor * zu(k), l_grid(k) )
+                ELSE
+                   l(k,j)  = MIN( l_grid(k), l_stable )
+                   ll(k,j) = l_grid(k)
+                ENDIF
+                IF ( adjust_mixing_length  .AND.  prandtl_layer )  THEN
+                   l(k,j)  = MIN( l(k,j),  kappa * zu(k) / phi_m )
+                   ll(k,j) = MIN( ll(k,j), kappa * zu(k) / phi_m )
+                ENDIF
+
+             ENDDO
+          ENDDO
+!
+!--       Calculate the tendency terms
+          DO  j = nys, nyn
+             DO  k = nzb_s_inner(j,i)+1, nzt-1
+
+                 dissipation(k,j) = ( 0.19 + 0.74 * l(k,j) / ll(k,j) ) * &
+                                    e(k,j,i) * SQRT( e(k,j,i) ) / l(k,j)
+
+                 tend(k,j,i) = tend(k,j,i)                                     &
+                                        + (                                    &
+                          ( km(k,j,i)+km(k,j,i+1) ) * ( e(k,j,i+1)-e(k,j,i) )  &
+                        - ( km(k,j,i)+km(k,j,i-1) ) * ( e(k,j,i)-e(k,j,i-1) )  &
+                                          ) * ddx2                             &
+                                        + (                                    &
+                          ( km(k,j,i)+km(k,j+1,i) ) * ( e(k,j+1,i)-e(k,j,i) )  &
+                        - ( km(k,j,i)+km(k,j-1,i) ) * ( e(k,j,i)-e(k,j-1,i) )  &
+                                          ) * ddy2                             &
+                                        + (                                    &
+               ( km(k,j,i)+km(k+1,j,i) ) * ( e(k+1,j,i)-e(k,j,i) ) * ddzu(k+1) &
+             - ( km(k,j,i)+km(k-1,j,i) ) * ( e(k,j,i)-e(k-1,j,i) ) * ddzu(k)   &
+                                          ) * ddzw(k)                          &
+                             - dissipation(k,j)
+
+             ENDDO
+          ENDDO
+
+!
+!--       Store dissipation if needed for calculating the sgs particle
+!--       velocities
+          IF ( use_sgs_for_particles )  THEN
+             DO  j = nys, nyn
+                DO  k = nzb_s_inner(j,i)+1, nzt-1
+                   diss(k,j,i) = dissipation(k,j)
+                ENDDO
+             ENDDO
+          ENDIF
+
+       ENDDO
+
+!
+!--    Boundary condition for dissipation
+       IF ( use_sgs_for_particles )  THEN
+          DO  i = nxl, nxr
+             DO  j = nys, nyn
+                diss(nzb_s_inner(j,i),j,i) = diss(nzb_s_inner(j,i)+1,j,i)
+             ENDDO
+          ENDDO
+       ENDIF
+
+    END SUBROUTINE diffusion_e
+
+
+!------------------------------------------------------------------------------!
+! Call for grid point i,j
+!------------------------------------------------------------------------------!
+    SUBROUTINE diffusion_e_ij( i, j, ddzu, dd2zu, ddzw, diss, e, km, l_grid, &
+                               theta, rif, tend, zu )
+
+       USE control_parameters
+       USE grid_variables
+       USE indices
+       USE particle_attributes
+
+       IMPLICIT NONE
+
+       INTEGER         ::  i, j, k
+       REAL            ::  dpt_dz, l_stable, phi_m
+       REAL            ::  ddzu(1:nzt+1), dd2zu(1:nzt), ddzw(1:nzt), &
+                           l_grid(1:nzt), zu(0:nzt+1)
+       REAL, DIMENSION(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1) ::  diss, tend
+       REAL, DIMENSION(:,:), POINTER   ::  rif
+       REAL, DIMENSION(:,:,:), POINTER ::  e, km, theta
+       REAL, DIMENSION(nzb+1:nzt-1)    ::  dissipation, l, ll
+
+
+!
+!--    First, calculate phi-function for eventually adjusting the mixing length
+!--    to the prandtl mixing length
+       IF ( adjust_mixing_length  .AND.  prandtl_layer )  THEN
+          IF ( rif(j,i) >= 0.0 )  THEN
+             phi_m = 1.0 + 5.0 * rif(j,i)
+          ELSE
+             phi_m = 1.0 / SQRT( SQRT( 1.0 - 16.0 * rif(j,i) ) )
+          ENDIF
+       ENDIF
+
+!
+!--    Calculate the mixing length (for dissipation)
+       DO  k = nzb_s_inner(j,i)+1, nzt-1
+          dpt_dz = ( theta(k+1,j,i) - theta(k-1,j,i) ) * dd2zu(k)
+          IF ( dpt_dz > 0.0 ) THEN
+             l_stable = 0.76 * SQRT( e(k,j,i) ) / &
+                               SQRT( g / theta(k,j,i) * dpt_dz ) + 1E-5
+          ELSE
+             l_stable = l_grid(k)
+          ENDIF
+!
+!--       Adjustment of the mixing length
+          IF ( wall_adjustment )  THEN
+             l(k)  = MIN( wall_adjustment_factor * zu(k), l_grid(k), l_stable )
+             ll(k) = MIN( wall_adjustment_factor * zu(k), l_grid(k) )
+          ELSE
+             l(k)  = MIN( l_grid(k), l_stable )
+             ll(k) = l_grid(k)
+          ENDIF
+          IF ( adjust_mixing_length  .AND.  prandtl_layer )  THEN
+             l(k)  = MIN( l(k),  kappa * zu(k) / phi_m )
+             ll(k) = MIN( ll(k), kappa * zu(k) / phi_m )
+          ENDIF
+
+!
+!--       Calculate the tendency term
+          dissipation(k) = ( 0.19 + 0.74 * l(k) / ll(k) ) * e(k,j,i) * &
+                           SQRT( e(k,j,i) ) / l(k)
+
+          tend(k,j,i) = tend(k,j,i)                                           &
+                                       + (                                    &
+                         ( km(k,j,i)+km(k,j,i+1) ) * ( e(k,j,i+1)-e(k,j,i) )  &
+                       - ( km(k,j,i)+km(k,j,i-1) ) * ( e(k,j,i)-e(k,j,i-1) )  &
+                                         ) * ddx2                             &
+                                       + (                                    &
+                         ( km(k,j,i)+km(k,j+1,i) ) * ( e(k,j+1,i)-e(k,j,i) )  &
+                       - ( km(k,j,i)+km(k,j-1,i) ) * ( e(k,j,i)-e(k,j-1,i) )  &
+                                         ) * ddy2                             &
+                                       + (                                    &
+              ( km(k,j,i)+km(k+1,j,i) ) * ( e(k+1,j,i)-e(k,j,i) ) * ddzu(k+1) &
+            - ( km(k,j,i)+km(k-1,j,i) ) * ( e(k,j,i)-e(k-1,j,i) ) * ddzu(k)   &
+                                         ) * ddzw(k)                          &
+                                       - dissipation(k)
+
+       ENDDO
+
+!
+!--    Store dissipation if needed for calculating the sgs particle velocities
+       IF ( use_sgs_for_particles )  THEN
+          DO  k = nzb_s_inner(j,i)+1, nzt-1
+             diss(k,j,i) = dissipation(k)
+          ENDDO
+!
+!--       Boundary condition for dissipation
+          diss(nzb_s_inner(j,i),j,i) = diss(nzb_s_inner(j,i)+1,j,i)
+       ENDIF
+
+    END SUBROUTINE diffusion_e_ij
+
+ END MODULE diffusion_e_mod
